From db73c8a30f61115af625d45c9b96d6b82e78bee4 Mon Sep 17 00:00:00 2001
From: Peter Wortmann <none@none>
Date: Sun, 8 May 2011 22:36:48 +0200
Subject: [PATCH 01/10] Fixed the surrender dialog showing after declined kick
 vote

---
 src/network/C4Network2.cpp |    6 ++++--
 1 files changed, 4 insertions(+), 2 deletions(-)

diff --git a/src/network/C4Network2.cpp b/src/network/C4Network2.cpp
index 6e24e0c..b2a7ea5 100644
--- a/src/network/C4Network2.cpp
+++ b/src/network/C4Network2.cpp
@@ -670,6 +670,7 @@ void C4Network2::Clear()
 	delete pVoteDialog; pVoteDialog = NULL;
 	fPausedForVote = false;
 	iLastOwnVoting = 0;
+	Votes.Clear();
 	// don't clear fPasswordNeeded here, it's needed by InitClient
 }
 
@@ -2526,7 +2527,7 @@ void C4Network2::Vote(C4ControlVoteType eType, bool fApprove, int32_t iData)
 		if (time(NULL) < (time_t) (iLastOwnVoting + C4NetMinVotingInterval))
 		{
 			Log(LoadResStr("IDS_TEXT_YOUCANONLYSTARTONEVOTINGE"));
-			if (eType == VT_Kick || eType == VT_Cancel)
+			if ((eType == VT_Kick && iData == Game.Clients.getLocalID()) || eType == VT_Cancel)
 				OpenSurrenderDialog(eType, iData);
 			return;
 		}
@@ -2599,7 +2600,8 @@ void C4Network2::EndVote(C4ControlVoteType eType, bool fApprove, int32_t iData)
 			pVoteDialog = NULL;
 		}
 	// Did we try to kick ourself? Ask if we'd like to surrender
-	if (!fApprove && (eType == VT_Kick || eType == VT_Cancel) && iOrigin == Game.Clients.getLocalID())
+	bool fCancelVote = (eType == VT_Kick && iData == Game.Clients.getLocalID()) || eType == VT_Cancel;
+	if (!fApprove && fCancelVote && iOrigin == Game.Clients.getLocalID())
 		OpenSurrenderDialog(eType, iData);
 	// Check if the dialog should be opened
 	OpenVoteDialog();
-- 
1.7.7.1

